unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    BitBtn1: TBitBtn;
    OpenDialog1: TOpenDialog;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TMPCHead = record
    Headchar: array[0..15] of byte;
    Headnull: array[0..11] of integer;
    Filedatalen: integer;   //ͷ
    MaxWide: integer;
    MaxHeight: integer;
    PicAmount: integer;
    PicBitCount: integer;
    PaletteLen: integer;
    Xs: integer;  //??
    Ys: integer;  //??
    Endnull: array[0..7] of integer;
  end;

  TMPCpalette = record
    bule: byte;
    green: byte;
    red: byte;
    alpha: byte; //??
  end;

  TMPCpichead = record
    picDataLen: integer;
    Wide: integer;
    Height: integer;
    Endnull: array[0..1] of integer;
  end;

  TMPCpicdata = record
    data: array of byte;
  end;

var
  Form1: TForm1;
  filename: string;
  picamount, piccount: integer;
  MPChead: TMPChead;
  MPCpalette: array of TMPCpalette;
  MPCpichead: array of TMPCpichead;
  MPCpicdata: array of TMPCpicdata;

procedure readfile;
procedure DisplayMPCpic;

implementation

{$R *.dfm}

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  opendialog1.filter:='ļ(*.*)|*.*';
  if opendialog1.Execute then
  begin
    filename := Opendialog1.FileName;
    BitBtn2.Enabled := true;
    BitBtn3.Enabled := true;
    readfile;
    displayMPCpic
  end;
end;

procedure readfile;
var
  openint, i: integer;
  offset: array of integer;
begin
  openint := fileopen(filename, fmopenread);
  fileseek(openint, 0, 0);
  fileread(openint, MPChead, 128);
  setlength(MPCpalette, MPChead.PaletteLen);
  setlength(MPCpichead, MPChead.PicAmount);
  setlength(MPCpicdata, MPChead.PicAmount);
  setlength(offset, MPChead.PicAmount);
  picamount := MPChead.PicAmount;
  piccount := 1;
  form1.Caption := 'MPC-' + filename + '-1/' + inttostr(picamount);
  fileread(openint, MPCpalette[0], MPChead.PaletteLen * 4);
  fileread(openint, Offset[0], picamount * 4);
  for i := 0 to picamount - 1 do
  begin
    fileread(openint, MPCpichead[i], 20);
    setlength(MPCpicdata[i].data, MPCpichead[i].picDataLen - 20);
    fileread(openint, MPCpicdata[i].data[0], MPCpichead[i].picDataLen - 20);
  end;
  fileclose(openint);
end;

procedure DisplayMPCpic;
var
  i, x, y, state: integer;
begin
  form1.image1.Canvas.Refresh;
  form1.image1.Canvas.FillRect(form1.image1.ClientRect);
  form1.Caption := 'MPC-' + filename + '-' + inttostr(piccount) + '/' + inttostr(picamount);
  x := 0;
  y := 0;
  state := 0;
  for i := 0 to MPCpichead[piccount - 1].picDataLen - 21 do
  begin
    if state = 0 then
    begin
      if MPCpicdata[piccount - 1].data[i] < 128 then
        state := MPCpicdata[piccount - 1].data[i]
      else
      begin
        inc(x, MPCpicdata[piccount - 1].data[i] - 128);
        if x >= MPCpichead[piccount - 1].Wide then
        begin
          inc(y);
          x := 0;
        end;
      end;
    end
    else
    begin
      if (x >= 0) and (y >= 0) and (x < form1.image1.Width) and (y < form1.Image1.Height) then
      begin
        form1.Image1.Canvas.Pixels[x, y] := RGB(MPCpalette[MPCpicdata[piccount - 1].data[i]].red, MPCpalette[MPCpicdata[piccount - 1].data[i]].green, MPCpalette[MPCpicdata[piccount - 1].data[i]].bule);
        inc(x);
      end;
      if x >= MPCpichead[piccount - 1].Wide then
      begin
        x := 0;
        inc(y);
      end;
      dec(state);
    end;
  end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  dec(piccount);
  if piccount = 0 then
    piccount := MPChead.PicAmount;
  displayMPCpic;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  inc(piccount);
  if piccount > MPChead.PicAmount then
    piccount := 1;
  displayMPCpic;
end;

end.
